# Compilers and linkers

OBJCC_I386 = /Xcode3/usr/bin/gcc-4.2 -arch i386
OBJCC_PPC = /Xcode3/usr/bin/gcc-4.0 -arch ppc
CC_I386 = /Xcode3/usr/bin/gcc-4.2 -arch i386
CC_PPC = /Xcode3/usr/bin/gcc-4.0 -arch ppc
CXX_I386 = /Xcode3/usr/bin/g++-4.2 -arch i386
CXX_PPC = /Xcode3/usr/bin/g++-4.0 -arch ppc
LD = /Xcode3/usr/bin/gcc-4.0
AR = ar
SDK = -isysroot /Xcode3/SDKs/MacOSX10.5.sdk

# Options for compilation

GCC_OPTS =	-O2 \
		-F../XADMaster \
		-F../UniversalDetector \
		-Wno-import \
		-Wno-multichar \
		-mmacosx-version-min=10.3.9 \
		-DIsLegacyVersion

OBJC_OPTS =	-std=gnu99 \
		$(SDK)

C_OPTS =	-std=gnu99 \
		$(SDK)

CXX_OPTS =	$(SDK)

AUTODEPENDENCY_CFLAGS=-MMD -MF$(@:.o=.d) -MT$@

ALL_OBJCFLAGS = $(OBJC_OPTS) $(GCC_OPTS) $(OBJCFLAGS)
ALL_CFLAGS = $(C_OPTS) $(GCC_OPTS) $(CFLAGS)
ALL_CXXFLAGS = $(CXX_OPTS) $(GCC_OPTS) $(CXXFLAGS)

# Options for linking

LIBS =	-framework Cocoa \
	-framework Carbon \
	-F../XADMaster \
	-framework XADMaster \
	-F../UniversalDetector \
	-framework UniversalDetector \
	-lobjc

ALL_LDFLAGS =	-arch i386 -arch ppc \
		-mmacosx-version-min=10.3.9 \
		$(SDK) \
		$(LDFLAGS)

# Paths

SOURCE_DIR = .
BUILD_DIR = Build

# Source files

OBJC_FILES =	CSFileTypeList.m \
		main.m \
		TUCancelButton.m \
		TUTaskListView.m \
		TUArchiveController.m \
		TUController.m \
		TUTaskQueue.m \
		TUArchiveTaskView.m \
		TUEncodingPopUp.m

C_FILES =

CXX_FILES =

# Object files

OBJS =	$(OBJC_FILES:%.m=$(BUILD_DIR)/%.o) \
	$(C_FILES:%.c=$(BUILD_DIR)/%.o) \
	$(CXX_FILES:%.cpp=$(BUILD_DIR)/%.o)

# App

APP_NAME = The\ Unarchiver

APP_FILES = $(APP_NAME).app

RESOURCE_FILES =	de.lproj \
			en.lproj \
			es.lproj \
			fr.lproj \
			it.lproj \
			ja.lproj \
			lv.lproj \
			nb.lproj \
			pl.lproj \
			pt-PT.lproj \
			ru.lproj \
			tr.lproj \
			ar.lproj \
			ProgressView.nib \
			WaitView.nib \
			close_hover.png \
			close_normal.png \
			close_press.png \
			error.png
ICON_FILES =	7z.icns \
		ace.icns \
		adf.icns \
		adz.icns \
		amiga.icns \
		archive.icns \
		bin.icns \
		bz2.icns \
		cab.icns \
		cbr.icns \
		cbz.icns \
		cpio.icns \
		dd.icns \
		dms.icns \
		exe.icns \
		gtar.icns \
		gz.icns \
		hqx.icns \
		jar.icns \
		lha.icns \
		rar.icns \
		rpm.icns \
		sea.icns \
		sit.icns \
		tar.icns \
		unarchiver.icns \
		z.icns \
		zip.icns

# Compilation rules

all: $(APP_FILES)

$(APP_NAME).app: \
$(APP_NAME).app/Contents/MacOS/$(APP_NAME) \
$(APP_NAME).app/Contents/Info.plist \
$(APP_NAME).app/Contents/Frameworks/XADMaster.framework \
$(APP_NAME).app/Contents/Frameworks/UniversalDetector.framework \
$(RESOURCE_FILES:%=$(APP_NAME).app/Contents/Resources/%) \
$(ICON_FILES:%=$(APP_NAME).app/Contents/Resources/%)

$(APP_NAME).app/Contents/MacOS/$(APP_NAME): \
../XADMaster/XADMaster.framework \
../UniversalDetector/UniversalDetector.framework \
$(OBJS)
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	$(LD) $(ALL_LDFLAGS) -o "$@" $(OBJS) $(LIBS)

$(APP_NAME).app/Contents/Info.plist: Info.plist
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cat "$^" |\
	perl -pe 's/\$$\{EXECUTABLE_NAME\}/$(subst \,,$(APP_NAME))/sg' |\
	perl -pe 's/\$$\{PRODUCT_NAME\}/$(subst \,,$(APP_NAME))/sg' |\
	perl -pe 's!<string>10.6.0</string>!<string>10.3.9</string>!sg' |\
	cat >"$@"

$(APP_NAME).app/Contents/Frameworks/XADMaster.framework: ../XADMaster/XADMaster.framework
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cp -R "$^" "$@"

$(APP_NAME).app/Contents/Frameworks/UniversalDetector.framework: ../UniversalDetector/UniversalDetector.framework
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cp -R "$^" "$@"

$(APP_NAME).app/Contents/Resources/%: %
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cp -R "$^" "$@"

$(APP_NAME).app/Contents/Resources/%: icons/%
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cp -R "$^" "$@"

$(APP_NAME).app/Contents/Resources/unarchiver.icns: icons/unarchiver-old.icns
	@mkdir -p "$(subst _,$(empty) $(empty),$(dir $(subst $(empty) $(empty),_,$@)))"
	cp -R "$^" "$@"

../XADMaster/XADMaster.framework:
	make -C ../XADMaster -f Makefile.legacy

../UniversalDetector/UniversalDetector.framework:
	make -C ../UniversalDetector -f Makefile.legacy

clean:
	rm -rf $(BUILD_DIR) $(APP_FILES)
	make -C ../XADMaster -f Makefile.legacy clean
	make -C ../UniversalDetector -f Makefile.legacy clean

# Suffix rules

.SUFFIXES: .o .c .m .cpp

$(BUILD_DIR)/%.o: $(SOURCE_DIR)/%.c
	@mkdir -p $(dir $@)
	$(CC_I386) $(ALL_CFLAGS) $(AUTODEPENDENCY_CFLAGS) -c $< -o $@.i386
	$(CC_PPC) $(ALL_CFLAGS) -c $< -o $@.ppc
	lipo -create $@.i386 $@.ppc -output $@

$(BUILD_DIR)/%.o: $(SOURCE_DIR)/%.m
	@mkdir -p $(dir $@)
	$(OBJCC_I386) $(ALL_OBJCFLAGS) $(AUTODEPENDENCY_CFLAGS) -c $< -o $@.i386
	$(OBJCC_PPC) $(ALL_OBJCFLAGS) -c $< -o $@.ppc
	lipo -create $@.i386 $@.ppc -output $@

$(BUILD_DIR)/%.o: $(SOURCE_DIR)/%.cpp
	@mkdir -p $(dir $@)
	$(CXX_I386) $(ALL_CXXFLAGS) $(AUTODEPENDENCY_CFLAGS) -c $< -o $@.i386
	$(CXX_PPC) $(ALL_CXXFLAGS) -c $< -o $@.ppc
	lipo -create $@.i386 $@.ppc -output $@

-include $(OBJS:.o=.d)
